<template>
  <b-container>
    <div class="background_bloc" />
    <h2 class="title">
      INTRODUCTION AU SITE
    </h2>
    <p>Lorem ipsum dolor sit amet. A recusandae suscipit ut laborum maiores hic laborum dolores qui velit sequi. Qui impedit quisquam est doloribus nemo in dicta fugit ut repellat consequuntur et esse nemo sed dolorem vitae. Ex repellat exercitationem aut facilis soluta eos fugit fugiat 33 facilis sequi! A dolorem explicabo sed recusandae consectetur non officiis voluptatem id laborum tenetur qui molestiae aspernatur.</p>
  </b-container>
  <b-container class="slide-nouveautes">
    <div class="d-flex justify-content-between align-items-center mb-4">
      <h2 class="mb-0">
        LES NOUVEAUTÉS
      </h2>
      <router-link
        :to="{ name:'ListingProduit'}"
        class="btn-cta"
      >
        Tout voir
      </router-link>
    </div>
    <carousel
      :settings="settings"
      :breakpoints="breakpoints"
    >
      <slide
        v-for="(produit, index) in produits"
        :key="produit"
      >
        <NomVendeur :id="produit.vendeur.id" />
        <CardProduit
          :id="produit.id"
          :id-vendeur="produit.vendeur.id"
          :titre="produit.titre"
          :prix="produit.prix"
          :image="produitsImg[index]"
        />
      </slide>
    </carousel>
  </b-container>
  <template v-if="(store.isConnected) && store.user.abonnements.length">
    <b-container>
      <div class="d-flex justify-content-between align-items-center mb-4">
        <h2 class="mb-0">
          VOS ABONNEMENTS
        </h2>
        <router-link
          :to="{ name:'ListingAbo'}"
          class="btn-cta"
        >
          Tout voir
        </router-link>
      </div>
    </b-container>
    <b-container>
      <b-row>
        <b-col 
          v-for="(produit, index) in produitsAbo"
          :key="produit"
          sm="12"
          md="4"
        >
          <NomVendeur :id="produit.vendeur_id" />
          <CardProduit
            :id="produit.id"
            :id-vendeur="produit.vendeur_id"
            :titre="produit.titre"
            :prix="produit.prix"
            :image="produitsImgAbo[index]"
          />
        </b-col>
      </b-row>
    </b-container>
  </template>
  <b-container>
    <div
      class="mansory"
    >
      <router-link
        v-for="cat in categorieName"
        :key="cat"
        :to="{ name:'ListingProduitCat', params: { cat: cat.id }}"
      >
        <h2 class="text-uppercase">
          {{ cat.nom }}
        </h2>
      </router-link>
    </div>
  </b-container>
  <b-container class="background_bloc--home">
    <p class="background_bloc--home-title">
      ET SI VOUS AUSSI VOUS AVIEZ DES CRÉATIONS A VENDRE ?
    </p>
    <a
      href="#"
      class="btn-cta"
    >En savoir plus</a>
  </b-container>
</template>
<script>
import { useStore } from '@/store/store'
import axios from 'axios';
import NomVendeur from '@/components/NomVendeur.vue'
import CardProduit from '@/components/CardProduit.vue'
import 'vue3-carousel/dist/carousel.css'
import { Carousel, Slide } from 'vue3-carousel'

  export default {
    components: {
      NomVendeur,
      CardProduit,
      Carousel,
      Slide
    },

    setup() {
      let store = useStore();
      return {
        token: store.token
      }
      
    },

    data() {

      let store = useStore();

      return {
        store,
        randomVendeur: [],
        url: process.env.VUE_APP_URL,
        produits: [],
        produitsImg: [],
        produitsAbo: [],
        produitsImgAbo: [],
        categorieName: [],
        // carousel settings
        settings: {
          itemsToShow: 1.2,
          autoplay: 5000,
          wrapAround: true
        },
        breakpoints: {
          700: {
            itemsToShow: 2.1,
          },
          992: {
            itemsToShow: 3,
          },
        },
      }

    },

    mounted() {
      
      //on récupère les nouveautés
      axios({
        method: 'get',
        url: this.url + "/api/produits/last",
      })
      .then(res =>  {
        let arr = res.data['hydra:member'];
        for (let i = 0; i < arr.length; i++) {
          const produit = arr[i];
          if(produit.mediaObjects[0] != undefined && produit.mediaObjects[0] != ''){
            this.produitsImg.push(produit.mediaObjects[0].contentUrl);
          } else {
            this.produitsImg.push('noimg');
          }
          this.produits.push(produit);
        }
      })
      .catch(err => {
          console.log(err);
      })

      //on récupère les catégories
      axios({
        method: 'get',
        url: this.url + "/api/categories/",
      })
      .then(res =>  {
        let arr = res.data['hydra:member'];
        for (let i = 0; i < arr.length; i++) {
          const categorie = arr[i];
          this.categorieName.push(categorie);
        }
      })
      .catch(err => {
          console.log(err);
      });

      this.store.fetchUser();

      //on récupère 3 produits des abonnements du user
      if(this.store.user){
        axios({
          method: 'get',
          url: this.url + "/api/abonnements/random/" + this.store.user.id,
        })
        .then(res =>  {
          let arrAbo = res.data['hydra:member'];
          for (let i = 0; i < arrAbo.length; i++) {
            const produitAbo = arrAbo[i];
            if(produitAbo.file_path != undefined){
              this.produitsImgAbo.push('/media/' + produitAbo.file_path);
            } else {
              this.produitsImgAbo.push('media/noimg');
            }
            this.produitsAbo.push(produitAbo);
          }
        })
        .catch(err => {
            console.log(err);
        })
      }
    },

  }
</script>

<style lang="scss" scoped>
.slide-nouveautes {
  .carousel__slide {
    display: block;
    padding-right: calc(var(--bs-gutter-x) * 0.5);
    padding-left: calc(var(--bs-gutter-x) * 0.5);
  }
  .carousel__pagination {
    padding: 0;
  }
}
.background_bloc--home {
    width: 100%;
    background-color: #F6F0EB;
    height: 50vh;
    padding-left: 35%;
    &-title {
      border-left: 1px solid #7A8ABA;
      padding: 20px 0 20px 15px;
      font-size: 2rem;
      width: fit-content;
    }
    @media (max-width: 576px) {
      padding: 2%;
    }
  }

  .mansory {
    display: grid;
    grid-template-columns: repeat(6, 1fr);
    grid-template-rows: repeat(2, 1fr);
    text-align: left;
    height: 80vh;
    cursor: pointer;
    a:nth-child(1n) {
      background-repeat: no-repeat;
      display: flex;
      align-items: flex-end;
      background-size: cover;
      filter: brightness(85%);
      transition: all .5s ease;
      &:hover {
        filter: brightness(100%);
      }
      h2 {
        font-size: calc(1.325rem + -0.1vw);
        padding: 25px;
        color: #fff;
        font-family: 'Lato';
        width: 50%;
        margin-bottom: 0;
        border-left: none;
        @media (max-width: 768px) {
          padding: 5px;
        }
      }
    }
    a:nth-child(1) {
      grid-area: 1 / 1 / 3 / 3;
      background-image: url('@/assets/images/art-home.png');
    }
    a:nth-child(2) {
      grid-area: 1 / 3 / 2 / 7;
      background-image: url('@/assets/images/maison-home.png');
    }
    a:nth-child(3) {
      grid-area: 2 / 3 /3 / 6;
      background-image: url('@/assets/images/vetement-home.png');
    }
    a:nth-child(4) {
      grid-area: 2 / 6 / 3 / 7;
      background-image: url('@/assets/images/divers-home.png');
    }
    @media (max-width: 768px) {
      grid-template-columns: repeat(2, 1fr);
      grid-template-rows: repeat(2, 1fr);
      a:nth-child(1) {
        grid-column: 1;
        grid-row: 1;
        background-image: url('@/assets/images/art-home.png');
      }
      a:nth-child(2) {
        grid-column: 2;
        grid-row: 1;
        background-image: url('@/assets/images/maison-home.png');
      }
      a:nth-child(3) {
        grid-column: 1;
        grid-row: 2;
        background-image: url('@/assets/images/vetement-home.png');
      }
      a:nth-child(4) {
        grid-column: 2;
        grid-row: 2;
        background-image: url('@/assets/images/divers-home.png');
      }
    }
  }

  @media (min-width: 540px) {
    .background-bloc {
      margin-top: -5%; 
      width: 40%;
    }
  }
  
</style>